package com.example.switchyard.bpm_signal_event;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.switchyard.Exchange;
import org.switchyard.ExchangeHandler;
import org.switchyard.HandlerException;
import org.switchyard.Message;
import org.switchyard.test.Invoker;
import org.switchyard.test.ServiceOperation;
import org.switchyard.test.SwitchYardRunner;
import org.switchyard.test.SwitchYardTestCaseConfig;
import org.switchyard.test.SwitchYardTestKit;
import org.switchyard.test.mixins.CDIMixIn;
import org.switchyard.test.mixins.HTTPMixIn;

@RunWith(SwitchYardRunner.class)
@SwitchYardTestCaseConfig(mixins = {CDIMixIn.class, HTTPMixIn.class}, config = SwitchYardTestCaseConfig.SWITCHYARD_XML)
public class MyProcessTest {

	@ServiceOperation("MyProcess")
	private Invoker service;
	private HTTPMixIn httpMixIn;
	
	/**
	 * !! Start your SwitchYard service before you run this test.
	 * 
	 * Start a process, send a signal to the process and finish the process.
	 * @throws Exception
	 */
	@Test
	public void testBpmSignalEvent() throws Exception {
		// Send a SOAP request to start a BPM process
        httpMixIn.postResource("http://localhost:8080/bpm_signal_event/MyProcess",
        		"/xml/soap-request-start.xml");
		
        // Send a SOAP request to send a signal to BPM process
        httpMixIn.postResource("http://localhost:8080/bpm_signal_event/MyProcess",
        		"/xml/soap-request-signal.xml");
        		
		// validate the results
		Assert.assertTrue("Implement me", false);
	}

	//XXX For reference
//	@Test
//	public void testSignal() throws Exception {
//		// TODO Auto-generated method stub
//		// initialize your test message
//		Object message = null;
//		service.operation("signal").sendInOnly(message);
//
//		// validate the results
//		Assert.assertTrue("Implement me", false);
//	}
//
//	@Test
//	public void testStart() throws Exception {
//		// TODO Auto-generated method stub
//		// initialize your test message
//		Object message = null;
//		String result = service.operation("start").sendInOut(message)
//				.getContent(String.class);
//
//		// validate the results
//		Assert.assertTrue("Implement me", false);
//	}
//
//	@Test
//	public void testStop() throws Exception {
//		// TODO Auto-generated method stub
//		// initialize your test message
//		Object message = null;
//		service.operation("stop").sendInOnly(message);
//
//		// validate the results
//		Assert.assertTrue("Implement me", false);
//	}

	
//	private SwitchYardTestKit testKit;
//	 
//    @Test   
//    public void testOperation() {
//        MyTestServiceHandler service = new MyTestServiceHandler();
// 
//        // register the service...
//        testKit.registerInOutService("MyService", service);
//       
//        // invoke the service and capture the response...
//        Message response = newInvoker("MyService").sendInOut("<create>A1234</create>");
// 
//        // test the response content by doing an XML comparison with a
//        // file resource on the classpath...
//        testKit.compareXMLToResource(response.getContent(String.class), "/myservice/expected-create-response.xml");
//    }
    
}

class MyTestServiceHandler implements ExchangeHandler {

	@Override
	public void handleMessage(Exchange exchange) throws HandlerException {
		// TODO Auto-generated method stub

	}

	@Override
	public void handleFault(Exchange exchange) {
		// TODO Auto-generated method stub

	}
}
